import { Middleware, Dispatch } from "redux";
import { AuthorizationSetting, User } from "./model";
export declare const UNAUTHORIZED_ERROR = "Not authorized to view this route";
export declare const UNAUTHENTICATED_ERROR = "Not authenticated";
export declare type AuthPayload = {
    authorize: AuthorizationSetting;
    parent?: AuthPayload;
};
export declare type ShouldHandleError = (error: any) => boolean;
export interface AuthMiddlewareOptions<TState, TAction> {
    actionType: string;
    getUser: (state: TState) => User;
    getAuthPayload: (action: TAction) => AuthPayload;
    unauthorizedAction: any;
    unauthenticatedAction?: any;
    unauthorizedError?: string;
    unauthenticatedError?: string;
    handleUnauthenticatedApiErrors?: boolean | ShouldHandleError;
    handleUnauthorizedApiErrors?: boolean | ShouldHandleError;
}
export declare const configureAuthMiddleware: <TState, TAction>(options: AuthMiddlewareOptions<TState, TAction>) => Middleware<{}, any, Dispatch<import("redux").AnyAction>>;
