"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var isAuthorized_1 = require("./isAuthorized");
exports.UNAUTHORIZED_ERROR = "Not authorized to view this route";
exports.UNAUTHENTICATED_ERROR = "Not authenticated";
exports.configureAuthMiddleware = function (options) {
    var actionType = options.actionType, getAuthPayload = options.getAuthPayload, getUser = options.getUser, unauthenticatedAction = options.unauthenticatedAction, unauthorizedAction = options.unauthorizedAction, handleUnauthenticatedApiErrors = options.handleUnauthenticatedApiErrors, handleUnauthorizedApiErrors = options.handleUnauthorizedApiErrors;
    var unauthorizedError = options.unauthorizedError || exports.UNAUTHORIZED_ERROR;
    var unauthenticatedError = options.unauthenticatedError || exports.UNAUTHENTICATED_ERROR;
    var isUnauthenticatedError = typeof handleUnauthenticatedApiErrors === "function"
        ? handleUnauthenticatedApiErrors
        : handleUnauthenticatedApiErrors && (function (error) { return error.response.status === 401; });
    var isUnauthorizedError = typeof handleUnauthorizedApiErrors === "function"
        ? handleUnauthorizedApiErrors
        : handleUnauthorizedApiErrors && (function (error) { return error.response.status === 403; });
    var handleUnauthenticated = function (api) {
        api.dispatch(unauthenticatedAction || unauthorizedAction);
        throw new Error(unauthenticatedError);
    };
    var handleUnauthorized = function (api) {
        api.dispatch(unauthorizedAction);
        throw new Error(unauthorizedError);
    };
    return function (api) { return function (next) { return function (action) { return __awaiter(_this, void 0, void 0, function () {
        var user, result, authorize, parent, authResult, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (action.type === actionType) {
                        user = getUser(api.getState());
                        result = getAuthPayload(action);
                        authorize = result.authorize;
                        parent = result.parent;
                        while (authorize === undefined && parent !== undefined) {
                            authorize = parent.authorize;
                            parent = parent.parent;
                        }
                        authResult = isAuthorized_1.isAuthorized(user, authorize);
                        if (authResult === "Unauthenticated") {
                            handleUnauthenticated(api);
                        }
                        if (authResult === "Unauthorized") {
                            handleUnauthorized(api);
                        }
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, next(action)];
                case 2: return [2 /*return*/, _a.sent()];
                case 3:
                    e_1 = _a.sent();
                    if (isUnauthenticatedError && isUnauthenticatedError(e_1)) {
                        handleUnauthenticated(api);
                    }
                    if (isUnauthorizedError && isUnauthorizedError(e_1)) {
                        handleUnauthorized(api);
                    }
                    throw e_1;
                case 4: return [2 /*return*/];
            }
        });
    }); }; }; };
};
